<?php

function eme_gdpr_approve_url($email) {
   $def_language = eme_detect_lang();
   $language = $def_language;

   $the_link = eme_get_events_page();
   // some plugins add the lang info to the home_url, remove it so we don't get into trouble or add it twice
   $the_link = remove_query_arg('lang',$the_link);
   $nonce = wp_create_nonce("gdpr $email");
   $the_link = add_query_arg( array( 'eme_gdpr_approve' => $email, 'eme_gdpr_nonce'=>$nonce ), $the_link );
   if (!empty($language))
           $the_link = add_query_arg( array( 'lang' => $language ), $the_link );
   return $the_link;
}

function eme_gdpr_url($email) {
   $def_language = eme_detect_lang();
   $language = $def_language;

   $the_link = eme_get_events_page();
   // some plugins add the lang info to the home_url, remove it so we don't get into trouble or add it twice
   $the_link = remove_query_arg('lang',$the_link);
   $nonce = wp_create_nonce("gdpr $email");
   $the_link = add_query_arg( array( 'eme_gdpr' => $email, 'eme_gdpr_nonce'=>$nonce ), $the_link );
   if (!empty($language))
           $the_link = add_query_arg( array( 'lang' => $language ), $the_link );
   return $the_link;
}

function eme_gdpr_shortcode() {
	global $wp;
	$current_url = home_url(add_query_arg(array(),$wp->request));

	$always_queue = get_option('eme_always_queue_mails');

	if (isset($_POST['eme_action']) && $_POST['eme_action']=='eme_gdpr_mail' && isset($_POST['eme_email'])) {
		// send email to client if it exists, otherwise do nothing, but always return the same message
		$email=sanitize_email($_POST['eme_email']);
		// check if email is found, if so: send the gdpr url
		// eme_gdpr_url($email)
		if (eme_count_persons_by_email($email)>0) {
			$contact = eme_get_contact(0);
			$contact_email = $contact->user_email;
			$contact_name = $contact->display_name;
			$gdpr_link=eme_gdpr_url($email);
			$gdpr_subject=eme_translate(get_option('eme_gdpr_subject'));
			$gdpr_body=eme_translate(get_option('eme_gdpr_body'));
			$gdpr_body=str_replace('#_GDPR_URL', $gdpr_link ,$gdpr_body );
			eme_send_mail($gdpr_subject,$gdpr_body, $email, '', $contact_email, $contact_name, $always_queue);
		}
		$output= '<div id="message" class="info" style="background-color: rgb(255, 251, 204);">';
		$output .= __('Thank you for your request, an email will be sent with further info','events-made-easy');
		$output .= '</div>';
	} else {
		$output ="
   <form id='eme_gdpr_form' method='post' action='#'>
   <input type='hidden' name='eme_action' value='eme_gdpr_mail' />
   <input type='email' name='eme_email' value='' placeholder='".__('E-mail','events-made-easy')."' />
   <input type='submit' value='".__ ( 'Request person data','events-made-easy')."' name='doaction' id='doaction' class='button-primary action' />
   </form>";
	}
	return $output;
}

function eme_gdpr_approve_shortcode() {
	global $wp;
	$current_url = home_url(add_query_arg(array(),$wp->request));

	$always_queue = get_option('eme_always_queue_mails');

	if (isset($_POST['eme_action']) && $_POST['eme_action']=='eme_gdpr_approve_mail' && isset($_POST['eme_email'])) {
		// send email to client if it exists, otherwise do nothing, but always return the same message
		$email=sanitize_email($_POST['eme_email']);
		// check if email is found, if so: send the gdpr url
		// eme_gdpr_url($email)
		if (eme_count_persons_by_email($email)>0) {
			$contact = eme_get_contact(0);
			$contact_email = $contact->user_email;
			$contact_name = $contact->display_name;
			$gdpr_link=eme_gdpr_approve_url($email);
			$gdpr_subject=eme_translate(get_option('eme_gdpr_approve_subject'));
			$gdpr_body=eme_translate(get_option('eme_gdpr_approve_body'));
			$gdpr_body=str_replace('#_GDPR_APPROVE_URL', $gdpr_link ,$gdpr_body );
			eme_send_mail($gdpr_subject,$gdpr_body, $email, '', $contact_email, $contact_name, $always_queue);
		}
		$output= '<div id="message" class="info" style="background-color: rgb(255, 251, 204);">';
		$output .= __('Thank you for your request, an email will be sent with further info','events-made-easy');
		$output .= '</div>';
	} else {
		$output ="
   <form id='eme_gdpr_form' method='post' action='#'>
   <input type='hidden' name='eme_action' value='eme_gdpr_approve_mail' />
   <input type='email' name='eme_email' value='' placeholder='".__('E-mail','events-made-easy')."' />
   <input type='submit' value='".__ ( 'Initiate GDPR approval','events-made-easy')."' name='doaction' id='doaction' class='button-primary action' />
   </form>";
	}
	return $output;
}

function eme_gdpr_approve_show() {
	print eme_translate(get_option('eme_gdpr_approve_page_content'));
}

function eme_gdpr_show($email) {
	print eme_translate(get_option('eme_gdpr_page_header'));
	if (eme_count_persons_by_email($email)>0) {
		$person_ids=eme_get_personids_by_email($email);
		$counted=count($person_ids);
		foreach ($person_ids as $person_id) {
			$person=eme_get_person($person_id);
			$answers = eme_get_person_answers($person['person_id']);
			$members = eme_get_members('','people.person_id='.$person['person_id']);
			$groups = join(',',eme_get_persongroup_names($person['person_id']));
			$massmail = $person['massmail'] ? __('Yes') : __('No');
			$gdpr = $person['gdpr'] ? __('Yes') : __('No');
			print '<table>';
			print '<tr><td>'.__('ID', 'events-made-easy').'</td><td>'.intval($person['person_id']).'</td></tr>';
			print '<tr><td>'.__('Last Name', 'events-made-easy').'</td><td>'.eme_esc_html($person['lastname']).'</td></tr>';
			print '<tr><td>'.__('First Name', 'events-made-easy').'</td><td>'.eme_esc_html($person['firstname']).'</td></tr>';
			print '<tr><td>'.__('E-mail', 'events-made-easy').'</td><td>'.eme_esc_html($person['email']).'</td></tr>';
			print '<tr><td>'.__('Address1', 'events-made-easy').'</td><td>'.eme_esc_html($person['address1']).'</td></tr>';
			print '<tr><td>'.__('Address2', 'events-made-easy').'</td><td>'.eme_esc_html($person['address2']).'</td></tr>';
			print '<tr><td>'.__('City', 'events-made-easy').'</td><td>'.eme_esc_html($person['city']).'</td></tr>';
			print '<tr><td>'.__('Zip', 'events-made-easy').'</td><td>'.eme_esc_html($person['zip']).'</td></tr>';
			print '<tr><td>'.__('State', 'events-made-easy').'</td><td>'.eme_esc_html(eme_get_state_name($person['state_code'], $person['country_code'], $person['lang'])).'</td></tr>';
			print '<tr><td>'.__('Country', 'events-made-easy').'</td><td>'.eme_esc_html(eme_get_country_name($person['country_code'], $person['lang'])).'</td></tr>';
			print '<tr><td>'.__('Phone number', 'events-made-easy').'</td><td>'.eme_esc_html($person['phone']).'</td></tr>';
			print '<tr><td>'.__('MassMail', 'events-made-easy').'</td><td>'.$massmail.'</td></tr>';
			print '<tr><td>'.__('GDPR approval', 'events-made-easy').'</td><td>'.$gdpr.'</td></tr>';
			print '<tr><td>'.__('Member of group(s)', 'events-made-easy').'</td><td>'.eme_esc_html($groups).'</td></tr>';
			foreach ($answers as $answer) {
				$formfield = eme_get_formfield($answer['field_id']);
				$name = eme_trans_esc_html($formfield['field_name']);
				$tmp_answer = eme_answer2readable($answer['answer'],$formfield,1,"<br />","html");
				print "<tr><td>$name</td><td>$tmp_answer</td></tr>";
			}
			// Now the media
			$files = eme_get_uploaded_files($person_id,"people");
			if (!empty($files)) {
				foreach ($files as $file) {
					print '<tr><td>'.eme_trans_esc_html($file['field_name']).'</td><td>'."<a href='".$file['url']."'>".eme_esc_html($file['name']).'</a></td></tr>';
				}
                        }
			print '</table>';
			if (count($members)>0) {
			   print "<br />".__('Memberships','events-made-easy')."<br />";
			   foreach ($members as $member) {
				$start_date = ($member['start_date'] == '0000-00-00' || $member['start_date'] == '' ) ? '' : eme_localized_date($member['start_date']);
				$end_date = ($member['end_date'] == '0000-00-00' || $member['end_date'] == '') ? '' : eme_localized_date($member['end_date']);
				print '<table>';
				print '<tr><td>'.__('ID', 'events-made-easy').'</td><td>'.intval($member['member_id']).'</td></tr>';
				print '<tr><td>'.__('Membership', 'events-made-easy').'</td><td>'.eme_esc_html($member['membership_name']).'</td></tr>';
				print '<tr><td>'.__('Start', 'events-made-easy').'</td><td>'.$start_date.'</td></tr>';
				print '<tr><td>'.__('End', 'events-made-easy').'</td><td>'.$end_date.'</td></tr>';
				$answers=eme_get_member_answers($member['member_id']);
				foreach ($answers as $answer) {
					$formfield = eme_get_formfield($answer['field_id']);
					$name = eme_trans_esc_html($formfield['field_name']);
					$tmp_answer = eme_answer2readable($answer['answer'],$formfield,1,"<br />","html");
					print "<tr><td>$name</td><td>$tmp_answer</td></tr>";
				}
				// Now the media
				$files = eme_get_uploaded_files($member['member_id'],"members");
				if (!empty($files)) {
					foreach ($files as $file) {
						print '<tr><td>'.eme_trans_esc_html($file['field_name']).'</td><td>'."<a href='".$file['url']."'>".eme_esc_html($file['name']).'</a></td></tr>';
					}
				}
				print '</table>';
			   }
			}
			if ($counted>1)
			   print "<hr />";
		}
	}
	print eme_translate(get_option('eme_gdpr_page_footer'));
}

/**
 * Add the suggested privacy policy text to the policy postbox.
 */
function eme_gdpr_add_suggested_privacy_content() {
        $content =
        '<h2>' . __( 'What personal data we collect and why we collect it', 'events-made-easy' ) . '</h2>' .
        '<p>' . __( 'EME collects data based on the RSVP and member forms and optionally extra info in the backend for people. These are configured using by the person operating the site and thus should be explained in a global manner.', 'events-made-easy' ) . '</p>'.
        '<p>' . __( 'The data export will not show the info stored by RSVP forms if that info was unique to that event, however upon deletion all that data will be removed too.','events-made-easy').'</p>'.
        '<p>' . __( 'EME optionally uses a cookie to store the client date and time in order to adjust for client/server time differences when showing event dates and times.','events-made-easy').'</p>';

	if (function_exists('wp_add_privacy_policy_content'))
		wp_add_privacy_policy_content( __( 'Events Made Easy','events-made-easy' ), $content );
}

function eme_gdpr_register_exporters( $exporters ) {
	$exporters[] = array(
		'exporter_friendly_name' => __( 'Events Made Easy' ),
		'callback'               => 'eme_gdpr_user_data_exporter',
	);
	return $exporters;
}
function eme_gdpr_user_data_exporter( $email, $page = 1 ) {
	$export_items = array();
	if (eme_count_persons_by_email($email)>0) {
		$person_ids=eme_get_personids_by_email($email);
		foreach ($person_ids as $person_id) {
			$person=eme_get_person($person_id);
			$answers = eme_get_person_answers($person['person_id']);
			$members = eme_get_members('','people.person_id='.$person['person_id']);
			$groups = join(',',eme_get_persongroup_names($person['person_id']));
			$massmail = $person['massmail'] ? __('Yes') : __('No');
			$gdpr = $person['gdpr'] ? __('Yes') : __('No');
			$data = array();
			$data[] = array(
				'name'  => __('Person ID', 'events-made-easy'),
				'value' => $person['person_id']
			);
			$data[] = array(
				'name'  => __('Last Name', 'events-made-easy'),
				'value' => $person['lastname']
			);
			$data[] = array(
				'name'  => __('First Name', 'events-made-easy'),
				'value' => $person['firstname']
			);
			$data[] = array(
				'name'  => __('E-mail', 'events-made-easy'),
				'value' => $person['email']
			);
			$data[] = array(
				'name'  => __('Address1', 'events-made-easy'),
				'value' => $person['address1']
			);
			$data[] = array(
				'name'  => __('Address2', 'events-made-easy'),
				'value' => $person['address2']
			);
			$data[] = array(
				'name'  => __('City', 'events-made-easy'),
				'value' => $person['city']
			);
			$data[] = array(
				'name'  => __('Zip', 'events-made-easy'),
				'value' => $person['zip']
			);
			$data[] = array(
				'name'  => __('State', 'events-made-easy'),
				'value' => eme_get_state_name($person['state_code'], $person['country_code'], $person['lang'])
			);
			$data[] = array(
				'name'  => __('Country', 'events-made-easy'),
				'value' => eme_get_country_name($person['country_code'], $person['lang'])
			);
			$data[] = array(
				'name'  => __('Phone number', 'events-made-easy'),
				'value' => $person['phone']
			);
			$data[] = array(
				'name'  => __('MassMail', 'events-made-easy'),
				'value' => $massmail
			);
			$data[] = array(
				'name'  => __('GDPR approval', 'events-made-easy'),
				'value' => $gdpr
			);
			$data[] = array(
				'name'  => __('Member of group(s)', 'events-made-easy'),
				'value' => $groups
			);
			foreach ($answers as $answer) {
				$formfield = eme_get_formfield($answer['field_id']);
				$data[] = array(
					'name'  => eme_translate($formfield['field_name']),
					'value' => eme_answer2readable($answer['answer'],$formfield,1,",","text")
				);
			}
			// Add this group of items to the exporters data array.
			$group_id = 'eme-personal-data';
			$group_label = __( 'Events Made Easy Personal Data','event-made-easy' );
			$export_items[] = array(
				'group_id'    => $group_id,
				'group_label' => $group_label,
				'item_id'     => $person_id,
				'data'        => $data,
			);

			// Now the media
			$files = eme_get_uploaded_files($person_id,"people");
			if (!empty($files)) {
				$group_id = 'eme-personal-data-media';
				$group_label = __( 'Events Made Easy Personal Data Media','event-made-easy' );
				$data = array();
				foreach ($files as $file) {
					$data[] = array(
						'name'  => eme_translate($file['field_name']),
						'value' => "<a href='".$file['url']."'>".$file['name']."</a>"
					);
				}
				$export_items[] = array(
					'group_id'    => $group_id,
					'group_label' => $group_label,
					'item_id'     => $person_id,
					'data'        => $data,
				);
                        }

			if (count($members)>0) {
			   foreach ($members as $member) {
				$start_date = ($member['start_date'] == '0000-00-00' || $member['start_date'] == '' ) ? '' : eme_localized_date($member['start_date']);
				$end_date = ($member['end_date'] == '0000-00-00' || $member['end_date'] == '') ? '' : eme_localized_date($member['end_date']);
				$data = array();
				$data[] = array(
					'name'  => __('Member ID', 'events-made-easy'),
					'value' => $member['member_id']
				);
				$data[] = array(
					'name'  => __('Membership', 'events-made-easy'),
					'value' => $member['membership_name']
				);
				$data[] = array(
					'name'  => __('Start', 'events-made-easy'),
					'value' => $start_date
				);
				$data[] = array(
					'name'  => __('End', 'events-made-easy'),
					'value' => $end_date
				);
				$answers=eme_get_member_answers($member['member_id']);
				foreach ($answers as $answer) {
					$formfield = eme_get_formfield($answer['field_id']);
					$data[] = array(
						'name'  => eme_translate($formfield['field_name']),
						'value' => eme_answer2readable($answer['answer'],$formfield,1,",","text")
					);
				}
				$group_id = 'eme-member-data';
				$group_label = __( 'Events Made Easy Member Data','event-made-easy' );
				$export_items[] = array(
					'group_id'    => $group_id,
					'group_label' => $group_label,
					'item_id'     => $member['member_id'],
					'data'        => $data,
				);
				// Now the media
				$files = eme_get_uploaded_files($member['member_id'],"members");
				if (!empty($files)) {
					$group_id = 'eme-member-data-media';
					$group_label = __( 'Events Made Easy Member Data Media','event-made-easy' );
					$data = array();
					foreach ($files as $file) {
						$data[] = array(
							'name'  => eme_translate($file['field_name']),
							'value' => "<a href='".$file['url']."'>".$file['name']."</a>"
						);
					}
					$export_items[] = array(
						'group_id'    => $group_id,
						'group_label' => $group_label,
						'item_id'     => $person_id,
						'data'        => $data,
					);
				}
			   }
			}
		}
	}
	// Returns an array of exported items for this pass, but also a boolean whether this exporter is finished.
	//If not it will be called again with $page increased by 1.
	return array(
		'data' => $export_items,
		'done' => true,
	);
}

function eme_gdpr_register_erasers( $erasers = array() ) {
	$erasers[] = array(
		'eraser_friendly_name' => __( 'Events Made Easy' ),
		'callback'               => 'eme_gdpr_user_data_eraser',
	);
	return $erasers;
}
function eme_gdpr_user_data_eraser( $email, $page = 1 ) {
	if ( empty( $email) ) {
		return array(
			'items_removed'  => false,
			'items_retained' => false,
			'messages'       => array(),
			'done'           => true,
		);
	}
	$person_ids=eme_get_personids_by_email($email);
	if (!empty($person_ids)) {
		$ids=join(',',$person_ids);
		eme_gdpr_trash_people($ids);
	}
	$items_removed  = true;
	$items_retained = false;
	$messages = array();
	$messages[]=__("All data from the plugin Events Made Easy related to this email has been removed, but don't forget this also cancelled the corresponding memberships!",'events-made-easy');
	return array(
		'items_removed'  => $items_removed,
		'items_retained' => $items_retained,
		'messages'       => $messages,
		'done'           => true,
	);
}

?>
