jQuery(document).ready(function ($) { 

        var memberfields = {
                member_id: {
                    key: true,
		    title: eme.translate_memberid,
                    visibility: 'hidden'
                },
		person_id: {
		    title: eme.translate_personid,
		    visibility: 'hidden'
		},
                lastname: {
		    title: eme.translate_lastname
                },
                firstname: {
		    title: eme.translate_firstname
                },
                email: {
		    title: eme.translate_email
                },
                membership_name: {
		    title: eme.translate_membership,
                    visibility: 'hidden'
                },
                start_date: {
		    title: eme.translate_startdate,
                    visibility: 'hidden'
                },
                end_date: {
		    title: eme.translate_enddate,
                    visibility: 'hidden'
                },
                creation_date: {
		    title: eme.translate_registrationdate,
                    visibility: 'hidden'
                },
                payment_date: {
		    title: eme.translate_paymentdate,
                    visibility: 'hidden'
                },
                paid: {
		    title: eme.translate_paid,
                    visibility: 'hidden'
                },
                pg: {
		    title: eme.translate_pg,
                    visibility: 'hidden'
                },
                pg_pid: {
		    title: eme.translate_pg_pid,
                    visibility: 'hidden'
                },
                reminder_date: {
		    title: eme.translate_lastreminder,
                    visibility: 'hidden'
                },
                reminder: {
		    title: eme.translate_nbrreminder,
                    visibility: 'hidden'
                },
                status: {
		    title: eme.translate_status,
                    visibility: 'hidden'
                }
	}
        if ($('#MembersTableContainer').length) {
                var extrafields=$('#MembersTableContainer').data('extrafields').toString().split(',');
                var extrafieldnames=$('#MembersTableContainer').data('extrafieldnames').toString().split(',');
                var extrafieldsearchable=$('#MembersTableContainer').data('extrafieldsearchable').toString().split(',');
                $.each(extrafields, function( index, value ) {
			if (value != '') {
	                        var fieldindex='FIELD_'+value;
        	                var extrafield = {};
				if (extrafieldsearchable[index]=='1') {
                                        searchable=true;
                                        sorting=true;
                                } else {
                                        searchable=false;
                                        sorting=false;
                                }
                	        extrafield[fieldindex] = {
                        	        title: extrafieldnames[index],
                                	searchable: searchable,
					sorting: sorting,
                                	visibility: 'hidden'
                        	};
                        	$.extend(memberfields,extrafield);
			}
                });

		//Prepare jtable plugin
		$('#MembersTableContainer').jtable({
			title: eme.translate_members,
			paging: true,
			sorting: true,
			multiSorting: true,
			toolbarsearch: true,
			jqueryuiTheme: true,
			defaultSorting: '',
			selecting: true, //Enable selecting
			multiselect: true, //Allow multiple selecting
			selectingCheckboxes: true, //Show checkboxes on first column
			selectOnRowClick: true,
			toolbar: {
				items: [{
						text: eme.translate_csv,
						click: function () {
							jtable_csv('#MembersTableContainer');
						}
					},
					{
						text: eme.translate_print,
						click: function () {
							$('#MembersTableContainer').printElement();
						}
					}
				]
			},
			actions: {
				listAction: ajaxurl+'?action=eme_members_list'
			},
			fields: memberfields
		});
		$('#MembersTableContainer').jtable('load', {
			'search_person': $('#search_person').val(),
			'search_memberstatus': $('#search_memberstatus').val(),
			'search_membershipids': $('#search_membershipids').val(),
			'search_memberid': $('#search_memberid').val(),
			'search_customfields': $('#search_customfields').val(),
			'search_customfieldids': $('#search_customfieldids').val()
		});
	}

        if ($('#MembershipsTableContainer').length) {
		$('#MembershipsTableContainer').jtable({
			title: eme.translate_memberships,
			paging: true,
			sorting: true,
			multiSorting: true,
			jqueryuiTheme: true,
			defaultSorting: 'name ASC',
			toolbarsearch: true,
			toolbarreset: false,
			selecting: true, //Enable selecting
			multiselect: true, //Allow multiple selecting
			selectingCheckboxes: true, //Show checkboxes on first column
			selectOnRowClick: true,
			actions: {
				listAction: ajaxurl+'?action=eme_memberships_list'
			},
			fields: {
				membership_id: {
					key: true,
					title: eme.translate_id,
					visibility: 'hidden'
				},
				name: {
					title: eme.translate_name
				},
				description: {
					title: eme.translate_description
				},
				membercount: {
					title: eme.translate_membercount,
					sorting: false
				},
				contact: {
					title: eme.translate_contact,
					sorting: false
				}
			}
		});
		$('#MembershipsTableContainer').jtable('load');
        }
 
        // Actions button
        $('#MembershipsActionsButton').button().click(function () {
           var selectedRows = $('#MembershipsTableContainer').jtable('selectedRows');
           var do_action = $('#eme_admin_action').val();
           var action_ok=1;
           if (selectedRows.length > 0) {
              if ((do_action=='deleteMemberships') && !confirm(eme.translate_areyousuretodeleteselected)) {
                 action_ok=0;
              }
              if (action_ok==1) {
                 $('#MembershipsActionsButton').text(eme.translate_pleasewait);
		 $('#MembershipsActionsButton').prop('disabled', true);
                 var ids = [];
                 selectedRows.each(function () {
                   ids.push($(this).data('record')['membership_id']);
                 });

                 var idsjoined = ids.join(); //will be such a string '2,5,7'
                 $.post(ajaxurl, {'membership_id': idsjoined, 'action': 'eme_manage_memberships', 'do_action': do_action, 'eme_admin_nonce': eme.translate_adminnonce }, function(data) {
			$('#MembershipsTableContainer').jtable('reload');
			$('#MembershipsActionsButton').text(eme.translate_apply);
		 	$('#MembershipsActionsButton').prop('disabled', false);
			$('div#memberships-message').html(data.htmlmessage);
			$('div#memberships-message').show();
			$('div#memberships-message').delay(3000).fadeOut('slow');
                 }, 'json');
              }
           } else {
              alert(eme.translate_pleaseselectrecords);
           }
           // return false to make sure the real form doesn't submit
           return false;
        });

        // Actions button
        $('#MembersActionsButton').button().click(function () {
           var selectedRows = $('#MembersTableContainer').jtable('selectedRows');
           var do_action = $('#eme_admin_action').val();
	   var send_mail = $('#send_mail').val();
	   var trash_person = $('#trash_person').val();
	   var pdf_template = $('#pdf_template').val();
	   var html_template = $('#html_template').val();

           var action_ok=1;
           if (selectedRows.length > 0) {
              if ((do_action=='deleteMembers') && !confirm(eme.translate_areyousuretodeleteselected)) {
                 action_ok=0;
              }
              if (action_ok==1) {
                 $('#MembersActionsButton').text(eme.translate_pleasewait);
		 $('#MembersActionsButton').prop('disabled', true);
                 var ids = [];
                 selectedRows.each(function () {
                   ids.push($(this).data('record')['member_id']);
                 });

                 var idsjoined = ids.join(); //will be such a string '2,5,7'
		 var form;
		 var params = {
			'member_id': idsjoined,
			'action': 'eme_manage_members',
			'do_action': do_action,
			'send_mail': send_mail,
			'trash_person': trash_person,
			'pdf_template': pdf_template,
			'html_template': html_template,
			'eme_admin_nonce': eme.translate_adminnonce };

		 if (do_action=='sendMails') {
                         form = $('<form method="POST" action="'+eme.translate_admin_sendmails_url+'">');
                         params = {
                                 'member_ids': idsjoined,
                                 'eme_admin_action': 'new_mailing'
                                 };
                         $.each(params, function(k, v) {
                                 form.append($('<input type="hidden" name="' + k + '" value="' + v + '">'));
                         });
                         $('body').append(form);
                         form.submit();
                         return false;
                 }

                 if (do_action=='pdf' || do_action=='html') {
			 form = $('<form method="POST" action="' + ajaxurl + '">');
			 $.each(params, function(k, v) {
				 form.append($('<input type="hidden" name="' + k + '" value="' + v + '">'));
			 });
			 $('body').append(form);
			 form.submit();
			 $('#MembersActionsButton').text(eme.translate_apply);
			 $('#MembersActionsButton').prop('disabled', false);
			 return false;
		 }
                 $.post(ajaxurl, params, function(data) {
	                        $('#MembersTableContainer').jtable('reload');
                                $('#MembersActionsButton').text(eme.translate_apply);
		                $('#MembersActionsButton').prop('disabled', false);
				$('div#members-message').html(data.htmlmessage);
				$('div#members-message').show();
			        $('div#members-message').delay(3000).fadeOut('slow');
                        }, 'json');
              }
           } else {
              alert(eme.translate_pleaseselectrecords);
           }
           // return false to make sure the real form doesn't submit
           return false;
        });
 
        // Re-load records when user click 'load records' button.
        $('#MembersLoadRecordsButton').click(function (e) {
           e.preventDefault();
           $('#MembersTableContainer').jtable('load', {
               'search_person': $('#search_person').val(),
               'search_memberstatus': $('#search_memberstatus').val(),
               'search_membershipids': $('#search_membershipids').val(),
               'search_memberid': $('#search_memberid').val(),
               'search_customfields': $('#search_customfields').val(),
               'search_customfieldids': $('#search_customfieldids').val()
           });
	   if ($('#search_person').val() || $('#search_memberstatus').val() || $('#search_membershipids').val() || $('#search_memberid').val() || $('#search_customfields').val() || $('#search_customfieldids').val()) {
		   $('#StoreQueryButton').show();
	   } else {
		   $('#StoreQueryButton').hide();
	   }
	   $('#StoreQueryDiv').hide();
           // return false to make sure the real form doesn't submit
           return false;
        });
	$('#StoreQueryButton').click(function (e) {
           e.preventDefault();
	   $('#StoreQueryButton').hide();
	   $('#StoreQueryDiv').show();
           // return false to make sure the real form doesn't submit
           return false;
	});
	$('#StoreQuerySubmitButton').click(function (e) {
           e.preventDefault();
	   var params = {
               'search_person': $('#search_person').val(),
               'search_memberstatus': $('#search_memberstatus').val(),
               'search_membershipids': $('#search_membershipids').val(),
               'search_memberid': $('#search_memberid').val(),
               'search_customfields': $('#search_customfields').val(),
               'search_customfieldids': $('#search_customfieldids').val(),
	       'action': 'eme_store_members_query',
	       'eme_admin_nonce': eme.translate_adminnonce,
               'dynamicgroupname': $('#dynamicgroupname').val()
	   };
           $.post(ajaxurl, params, function(data) {
		   $('#StoreQueryButton').hide();
		   $('#StoreQueryDiv').hide();
		   $('div#members-message').html(data.htmlmessage);
		   $('div#members-message').show();
		   $('div#members-message').delay(3000).fadeOut('slow');
           }, 'json');
           // return false to make sure the real form doesn't submit
           return false;
	});
	$('#StoreQueryButton').hide();
	$('#StoreQueryDiv').hide();

        $('.eme_select2_memberstatus_class').select2({
		placeholder: eme.translate_selectmemberstatus,
		width: '10%'
	});
        $('.eme_select2_memberships_class').select2({
		placeholder: eme.translate_selectmemberships,
		width: '10%'
	});
	// to make sure the placeholder shows after a hidden select2 is shown (bug workaround)
	$('.select2-search--inline, .select2-search__field').css('width', '100%');

        function updateShowHideFixedStartdate () {
           if ($('select#type').val() == 'fixed') {
              $('tr#startdate').show();
           } else {
              $('tr#startdate').hide();
           }
        }
	if ($('select#type').length) {
           $('select#type').change(updateShowHideFixedStartdate);
           updateShowHideFixedStartdate();
	}
        function updateShowHideReminder () {
           if ($('select#duration_period').val() == 'forever') {
              $('tr#reminder').hide();
              $('#duration_count').hide();
           } else {
              $('tr#reminder').show();
              $('#duration_count').show();
           }
        }
	if ($('select#duration_period').length) {
           $('select#duration_period').change(updateShowHideReminder);
           updateShowHideReminder();
	}

        function updateShowHideMemberState () {
           if ($('select#status_automatic').val() == '1') {
              $('select#status').attr('disabled', true);
           } else {
              $('select#status').attr('disabled', false);
           }
        }
	if ($('select#status_automatic').length) {
           $('select#status_automatic').change(updateShowHideMemberState);
           updateShowHideMemberState();
	}

	// initially the div is not shown using display:none, so jquery has time to render it and then we call show()
	if ($('#membership-tabs').length) {
		$('#membership-tabs').tabs();
		$('#membership-tabs').show();
	}

	// for autocomplete to work, the element needs to exist, otherwise JS errors occur
	// we check for that using length
	if ($('input[name=chooseperson]').length) {
		$('input[name=chooseperson]').autocomplete({
			source: function(request, response) {
				$.post(ajaxurl,
					{ q: request.term,
					  action: 'eme_autocomplete_people',
					  eme_searchlimit: 'people'
					},
					function(data){
						response($.map(data, function(item) {
							return {
								lastname: htmlDecode(item.lastname),
								firstname: htmlDecode(item.firstname),
								email: item.email,
								address1: htmlDecode(item.address1),
								address2: htmlDecode(item.address2),
								city: htmlDecode(item.city),
								zip: htmlDecode(item.zip),
								state: htmlDecode(item.state),
								country: htmlDecode(item.country),
								state_code: htmlDecode(item.state_code),
								country_code: htmlDecode(item.country_code),
								phone: item.phone,
								person_id: item.person_id,
								wp_id: item.wp_id
							};
						}));
					}, 'json');
			},
			select:function(evt, ui) {
				// when a person is selected, populate related fields in this form
				$('input[name=lastname]').val(ui.item.lastname).attr('readonly', true);
				$('input[name=firstname]').val(ui.item.firstname).attr('readonly', true);
				$('input[name=email]').val(ui.item.email).attr('readonly', true);
				$('input[name=person_id]').val(ui.item.person_id).attr('readonly', true);
				$('input[name=address1]').val(ui.item.address1).attr('readonly', true);
				$('input[name=address2]').val(ui.item.address2).attr('readonly', true);
				$('input[name=city]').val(ui.item.city).attr('readonly', true);
				$('input[name=zip]').val(ui.item.zip).attr('readonly', true);
				$('input[name=state]').val(ui.item.state).attr('readonly', true);
				$('input[name=state_code]').val(ui.item.state_code).attr('readonly', true);
				$('input[name=country]').val(ui.item.country).attr('readonly', true);
				$('input[name=country_code]').val(ui.item.country_code).attr('readonly', true);
				$('input[name=phone]').val(ui.item.phone).attr('readonly', true);
				$('input[name=chooseperson]').val(ui.item.lastname+' '+ui.item.firstname).attr('readonly', true);
				$('input[name=wp_id]').val(ui.item.wp_id);
				$('input[name=wp_id]').trigger('input');
				return false;
			},
			minLength: 2
		}).data( 'ui-autocomplete' )._renderItem = function( ul, item ) {
			return $( '<li></li>' )
				.append('<a><strong>'+htmlDecode(item.lastname)+' '+htmlDecode(item.firstname)+'</strong><br /><small>'+htmlDecode(item.email)+' - '+htmlDecode(item.phone)+ '</small></a>')
				.appendTo( ul );
		};
	}
	// if manual input: set the hidden field empty again
	$('input[name=chooseperson]').change(function() {
		if ($('input[name=chooseperson]').val()=='') {
			$('input[name=person_id]').val('');
			$('input[name=lastname]').val('').attr('readonly', false);
			$('input[name=firstname]').val('').attr('readonly', false);
			$('input[name=email]').val('').attr('readonly', false);
			$('input[name=address1]').val('').attr('readonly', false);
			$('input[name=address2]').val('').attr('readonly', false);
			$('input[name=city]').val('').attr('readonly', false);
			$('input[name=state]').val('').attr('readonly', false);
			$('input[name=zip]').val('').attr('readonly', false);
			$('input[name=state]').val('').attr('readonly', false);
			$('input[name=state_code]').val('').attr('readonly', false);
			$('input[name=country]').val('').attr('readonly', false);
			$('input[name=country_code]').val('').attr('readonly', false);
			$('input[name=phone]').val('').attr('readonly', false);
			$('input[name=wp_id]').val('');
			$('input[name=wp_id]').trigger('input');
		}
	});

	function updateShowHideStuff () {
           var action=$('select#eme_admin_action').val();
           if ($.inArray(action,['acceptPayment','stopMembership']) >= 0) {
	      $('#send_mail').val(1);
              $('span#span_sendmails').show();
	   } else if (action == 'markUnpaid') {
	      $('#send_mail').val(0);
              $('span#span_sendmails').show();
           } else {
              $('span#span_sendmails').hide();
           }
           if (action == 'deleteMembers') {
              $('span#span_trashperson').show();
           } else {
              $('span#span_trashperson').hide();
           }
           if (action == 'pdf') {
              $('span#span_pdftemplate').show();
           } else {
              $('span#span_pdftemplate').hide();
           }
           if (action == 'html') {
              $('span#span_htmltemplate').show();
           } else {
              $('span#span_htmltemplate').hide();
           }
        }
        jQuery('select#eme_admin_action').change(updateShowHideStuff);
        updateShowHideStuff();

        $('#newmember_attach_button').click(function(e) {
                e.preventDefault();
                var custom_uploader = wp.media({
                        title: eme.translate_addattachments,
                        button: {
                                text: eme.translate_addattachments
                        },
                        multiple: true  // Set this to true to allow multiple files to be selected
                }).on('select', function() {
                        var selection = custom_uploader.state().get('selection');
                        // using map is not really needed, but this way we can reuse the code if multiple=true
                        // var attachment = custom_uploader.state().get('selection').first().toJSON();
                        selection.map( function(attach) {
                                attachment = attach.toJSON();
                                $('#newmember_attach_links').append("<a target='_blank' href='"+attachment.url+"'>"+attachment.title+"</a><br />");
                                if ($('#eme_newmember_attach_ids').val() != '') {
                                        tmp_ids_arr=$('#eme_newmember_attach_ids').val().split(',');
                                } else {
                                        tmp_ids_arr=[];
                                }
                                tmp_ids_arr.push(attachment.id);
                                tmp_ids_val=tmp_ids_arr.join(',');
                                $('#eme_newmember_attach_ids').val(tmp_ids_val);
                                $('#newmember_attach_button').hide();
                                $('#newmember_remove_attach_button').show();
                        });
                }).open();
        });
        if ($('#eme_newmember_attach_ids').val() != '') {
                $('#newmember_attach_button').hide();
                $('#newmember_remove_attach_button').show();
        } else {
                $('#newmember_attach_button').show();
                $('#newmember_remove_attach_button').hide();
        }
        $('#newmember_remove_attach_button').click(function(e) {
                e.preventDefault();
                $('#newmember_attach_links').html('');
                $('#eme_newmember_attach_ids').val('');
                $('#newmember_attach_button').show();
                $('#newmember_remove_attach_button').hide();
        });

});
